/*
 *
 * Sada pomocnych funkci pro programovani jadra
 *
 */

#include "term.h"
#include "util.h"

/**
 * Vypise na terminal zadany retezec
 */
void kprint(char *s)
{
	while (*s) {
		term_putc(*s);
		s++;
	}
}

/**
 * Vypise na terminal zadene cele cislo
 */
void kprint_i(unsigned int i)
{
	char buf[33];
	uint_to_str(buf, i, 10);
	kprint(buf);
}

/**
 * Nastavi barvu textu vypsaneho funkcemi kprint*
 */
void kprint_color(int fg, int bg)
{
	term_color(fg, bg);
}

/**
 * Prevede cislo n na jeho textovou reprezentaci pri zakladu base
 * a vysledek ulozi do bufferu
 */
void uint_to_str(char *buf, unsigned int n, unsigned char base)
{
	static char *map = "0123456789abcdef";
	char revbuf[33];
	unsigned int size = 0;
	do {
		revbuf[size] = map[n % base];
		n /= base;
		size++;
	} while (n);

	for (int i = 0; i < size; i++) {
		buf[i] = revbuf[size - i - 1];
	}
	buf[size] = '\0';
}
